% Simplified Marsh Response Model
% SMEM V1.1
% M. Incio, M.C. Freitas, A.G Cunha, C. Antunes, M. Leira, V. Lopes, C.
% Andrade
% Faculty of Sciences of University of Lisbon
clear
ciclos = 0;
disp(' ')
disp('-------------------------------------------')
disp('  Simplified Marsh Response Model - SMRM  ')
disp('-------------------------------------------')
disp(' ')
disp('  Version: 1.1')
pause(0.5)
disp(' ')
disp('The SMEM intends to simulate the evolution of salt marsh areas in a')
disp('climate change context.');
disp(' ')
disp('Press any key to continue.')
disp(' ')
pause
%
% Digital terrain model (DTM)
disp(' ')
disp('-------------------------------------------------------------------')
mdt = input('DTM of the area: ');
while isempty(mdt)
    disp(' ')
    disp('DTM of the area is required.')
    disp(' ')
    mdt = input('DTM of the area: ');
end
disp(' ')
mdt_cortado = input('DTM of the marsh: ');
while isempty(mdt_cortado)
    disp(' ')
    disp('DTM of the marsh is required.')
    disp(' ')
    mdt_cortado = input('DTM of the marsh: ');
end
%
% RMSE
disp(' ')
RMSE = input('RMSE of the DTM (m): ');
if isempty(RMSE)
    disp(' ')
    disp('RMSE: ZERO')
    disp(' ')
    RMSE = 0;
end
disp('-------------------------------------------------------------------')
%
% Initial year definition
disp(' ')
pause(0.5)
disp(' ')
disp('-------------------------------------------------------------------')
disp('Initial and final years definition')
disp(' ')
datai = input('Initial year: ');
while isempty(datai) || datai < 2000
    disp(' ')
    disp('Initial year is required. It cannot be earlier than 2000.')
    disp(' ')
    datai = input('Initial year: ');
end
%
% Final year
disp(' ')
dataf = input('Final year: ');
while isempty(dataf) || dataf <= datai || dataf > 2100
    disp(' ')
    disp('Final year is required;')
    disp('It cannot be earlier thant the intial year');
    disp('It cannot be later than 2100.');
    disp(' ')
    dataf = input('Final year: ');
end
disp('-------------------------------------------------------------------')
% Definition of the transition levels among marsh subenvironments
disp(' ')
pause(0.5)
disp(' ')
disp('-------------------------------------------------------------------')
disp('Definition of the transition levels among marsh subenvironments')
%  Tidal flat / Low marsh
disp(' ')
PMAM = input('Transition level [TF / LM] (MHWN) (m): ');
while isempty(PMAM)
    disp(' ')
    disp('It is a required parameter.');
    disp(' ')
    PMAM = input('Transition level [TF / LM] (MHWN) (m): ');
end
%  Low marsh / High marsh
disp(' ')
PMMed = input('Transition level [LM / HM] (MHW) (m): ');
while isempty(PMMed)
    disp(' ')
    disp('It is a required parameter.')
    disp(' ')
    PMMed = input('Transition level [LM / HM] (MHW) (m): ');
end
%  Marsh growing limit
disp(' ')
PMAV = input('High marsh growing limit (MHWS) (m): ');
while isempty(PMAV)
    disp(' ')
    disp('It is a required parameter.')
    disp(' ')
    PMAV = input('High marsh growing limit (MHWS) (m): ');
end
disp('-------------------------------------------------------------------')
%
% Accretion rates
disp(' ')
pause(0.5)
disp(' ')
disp('-------------------------------------------------------------------')
disp('Accretion rates')
disp(' ')
% High marsh accretion rate
Taxa_AS = input('Accretion rate - High marsh (mm/year): ');
while isempty(Taxa_AS)
    disp(' ')
    disp('It is a required parameter.')
    disp(' ')
    Taxa_AS = input('Accretion rate - High marsh (mm/year): ');
end
Acc_AS = input('Acceleration - High marsh (mm/year^2): ');
if isempty(Acc_AS)
    disp(' ')
    disp('Acceleration: ZERO');
    disp(' ')
    Acc_AS = 0;
end
disp(' ')
% Low marsh accretion rate
Taxa_BS = input('Accretion rate - Low marsh (mm/year): ');
while isempty(Taxa_BS)
    disp(' ')
    disp('It is a required parameter.')
    disp(' ')
    Taxa_BS = input('Accretion rate - Low marsh (mm/year): ');
end
Acc_BS = input('Acceleration - Low marsh (mm/year^2): ');
if isempty(Acc_BS)
    disp(' ')
    disp('Acceleration: ZERO')
    disp(' ')
    Acc_BS = 0;
end
disp(' ')
% Tidal flat accretion rate
Taxa_RM = input('Accretion rate - Tidal flat (mm/year): ');
while isempty(Taxa_RM)
    disp(' ')
    disp('It is a required parameter.')
    disp(' ')
    Taxa_RM = input('Accretion rate - Tidal flat (mm/year): ');
end
Acc_RM = input('Acceleration - Tidal flat (mm/year^2): ');
if isempty(Acc_RM)
    disp(' ')
    disp('Acceleration: ZERO')
    disp(' ')
    Acc_RM = 0;
end
ASDisp = Taxa_AS;
BSDisp = Taxa_BS;
RMDisp = Taxa_RM;
%  Accretion rates: mm/year --> m/year
Taxa_AS = Taxa_AS/1000; % High marsh accretion rate in m/year
Taxa_BS = Taxa_BS/1000; % Low marsh accretion rate in m/year
Taxa_RM = Taxa_RM/1000; % Tidal flat accretion rate in m/year
disp('-------------------------------------------------------------------')
disp(' ')
pause(0.5)
%
% SLR scenario definition
disp(' ')
disp('-------------------------------------------------------------------')
disp('SLR rate and acceleration definition')
disp(' ')
% SLR initial rate
Taxa = input('SLR initial rate (mm/year): ');
while isempty(Taxa)
    disp(' ')
    disp('It is a required parameter.')
    disp(' ')
    Taxa = input('SLR initial rate (mm/year): ');
end
TaxaDisp = Taxa;
Taxa = Taxa / 1000; % SLR initial rate: mm/year --> m/year
%  SLR acceleration
disp(' ')
Acc = input('SLR acceleration (mm/year^2): ');
if isempty(Acc) || Acc == 0
    disp(' ')
    disp('SLR acceleration = 0.')
    Acc = 0;
else
end
AccDisp = Acc;
Acc = Acc / 1000; % SLR acceleration: mm/year^2 --> m/year^2
disp('-------------------------------------------------------------------')
disp(' ')
%
% Find initial MSL
AnoBASE = 2000:2021;
NMM2000_2021 = [0.125 0.127 0.130 0.132 0.135 0.138 0.141 0.144 0.147 0.151...
    0.155 0.158 0.162 0.167 0.171 0.175 0.180 0.185 0.190 0.195 0.200 0.205]; % MSL (2000->2021)
FindAnoBASE = find(AnoBASE == datai); % Find MSL to the initial year
NMM_inicial = NMM2000_2021(FindAnoBASE); % Find MSL to the initial year
%
% Read marsh area file
[mdtt, R_mdtt] = geotiffread(mdt); % Read file (mdtt: DTM; R_mdtt: Coordinate System)
[L_mdtt, C_mdtt] = size(mdtt); % Size of area DTM
[mdtcor, R_mdtcor] = geotiffread(mdt_cortado); % Read marsh DTM file
[L_mdt, C_mdt] = size(mdtcor); % Size of marsh DTM
mdtt_original = mdtt;
%
% Vectors
datas = datai:dataf; % Date vector
Anos = 1:(dataf-datai+1); % Years vector
NMM = zeros(length(datas),1); % MSL vector
Taxa_anual = zeros(length(datas),1); % Annual SLR rate vector
PMAV_anual = zeros(length(datas),1); % Annual MHWS vector
PMMed_anual = zeros(length(datas),1); % Annual MHW vector
PMAM_anual = zeros(length(datas),1); % Annual MHWN vector
AS_anual = zeros(length(datas),1); % Annual high marsh accretion rate vector
BS_anual = zeros(length(datas),1); % Annual low marsh accretion rate vector
RM_anual = zeros(length(datas),1); % Annual tidal flat accretion rate vector
Taxa_anual(1) = Taxa; % Initial SLR rate to the first vector value
NMM(1) = NMM_inicial + RMSE; % Initial MSL to the first vector value
PMAV_anual(1) = PMAV + RMSE; % Initial MHWS to the first vector value
PMMed_anual(1) = PMMed + RMSE; % initial MHW to the first vector value
PMAM_anual(1) = PMAM + RMSE; % Initial MHWN to the first vector value
AS_anual(1) = Taxa_AS; % Initial high marsh accretion rate
BS_anual(1) = Taxa_BS; % Initial low marsh accretion rate
RM_anual(1) = Taxa_RM; % Initial tidal flat accretion rate
%
%
pause(1)
disp(' ')
disp('-------------------------------------------------------------------')
disp('Before proceeding, check the following data: ')
disp(' ')
fprintf('The simulation will start in %G and end in %G.\n',datai,dataf)
disp(' ')
fprintf('The RMSE of the DTM is %G m.\n', RMSE)
disp(' ')
fprintf('The defined transition levels are: \n')
fprintf('                      MHWN: %G m \n',PMAM)
fprintf('                       MHW: %G m \n',PMMed)
fprintf('                      MHWS: %G m \n',PMAV)
fprintf('The provided values should include SLR.\n')
fprintf('It was considered a SLR of %G m in %G.\n', NMM_inicial, datai)
disp(' ')
fprintf('High marsh accretion rate: %G mm/year or %E m/year;\n',ASDisp,Taxa_AS)
if Acc_AS == 0
else
    fprintf('High marsh accretion rate acceleration: %G mm/year^2;\n',Acc_AS)
    disp(' ')
end
fprintf('Low marsh accretion rate:  %G mm/year or %E m/year;\n',BSDisp,Taxa_BS)
if Acc_BS == 0
else
    fprintf('Low marsh accretion rate acceleration: %G mm/year^2;\n',Acc_BS)
    disp(' ')
end
fprintf('Tidal flat accretion rate: %G mm/year or %E m/year.\n',RMDisp,Taxa_RM)
if Acc_RM == 0
else
    fprintf('Tidal flat accretion rate acceleration: %G mm/year^2.\n',Acc_RM)
end
disp(' ')
fprintf('The initial SLR rate is %G mm/year or %E m/year in %G;\n',TaxaDisp,Taxa,datai)
fprintf('SLR acceleration is %G mm/year^2 ou %E m/year^2.\n',AccDisp,Acc)
disp('-------------------------------------------------------------------')
disp(' ')
disp('If all values are correct, press any key to continue.');
disp(' ')
pause
disp('.')
pause(0.1)
disp('.')
pause(0.1)
disp('Processing...')
pause(0.1)
disp('.')
pause(0.1)
disp('.')
% Background values of DTM
for l = 1:L_mdtt
    for c = 1:C_mdtt
        if mdtt(l,c) < -100 || mdtt(l,c) > 100
            mdtt(l,c) = NaN;
        else
        end
        ciclos = ciclos + 1; % Cicle count
    end
    ciclos = ciclos + 1;
end
%
% Processing
for t = 2:length(Anos) % Annual iterations
    Taxa_anual(t) = Taxa_anual(t-1) + Acc; % SLR rate for each year
    NMM(t) = NMM(t-1) + Taxa_anual(t); % MSL for each year
    PMAV_anual(t) = PMAV_anual(t-1) + Taxa_anual(t); % MHWS for each year
    PMMed_anual(t) = PMMed_anual(t-1) + Taxa_anual(t); % MHW for each year
    PMAM_anual(t) = PMAM_anual(t-1) + Taxa_anual(t); % MHWN for each year
    AS_anual(t) = AS_anual(t-1) + Acc_AS/1000; % High marsh accretion rate for each year
    BS_anual(t) = BS_anual(t-1) + Acc_BS/1000; % Low marsh accretion rate for each year
    RM_anual(t) = RM_anual(t-1) + Acc_RM/1000; % Tidal flat accretion rate for each year
    for l = 1:L_mdtt % Processing each line of the DTM
        for c = 1:C_mdtt % Processing each column of the DTM
            if mdtt(l,c) >= PMAV_anual(t) || isnan(mdtt(l,c)) % If DTM height is higher than MHWS or NaN
                mdtt(l,c) = mdtt(l,c); % Sedimentation rate is not applied
            elseif mdtt(l,c) >= PMMed_anual(t) % If DTM height is between MHW and MHWs
                mdtt(l,c) = mdtt(l,c) + AS_anual(t); % High marsh sedimentation rate is applied
            elseif mdtt(l,c) >= PMAM_anual(t) % If DTM height is between MHWN and MHW
                mdtt(l,c) = mdtt(l,c) + BS_anual(t); % Low marsh sedimentation rate is applied
            elseif mdtt(l,c) < PMAM_anual(t) % If DTM height is lower than MHWN
                mdtt(l,c) = mdtt(l,c) + RM_anual(t); % Tidal flat sedimentation rate is applied
            else % Error check
                disp(' ')
                disp('Ops! Error.')
            end
            ciclos = ciclos + 1;
        end
        ciclos = ciclos + 1;
    end
    ciclos = ciclos + 1;
end
%
% Verification of which pixels were changed during the process
mdtt_alt = zeros(L_mdtt,C_mdtt); % It creates a new matrix with the size of the original DTM
for l = 1:L_mdtt
    for c = 1:C_mdtt
        if mdtt(l,c) == mdtt_original(l,c) % If the DTM cell did not changed
            mdtt_alt(l,c) = 0;
        else % If the DTM cell changed
            mdtt_alt(l,c) = 1;
        end
        ciclos = ciclos + 1;
    end
    ciclos = ciclos + 1;
end
mdtnew = NaN(L_mdt,C_mdt);
for i = 1:L_mdt
    for j = 1:C_mdt
        if mdtt_alt(i,j) == 0
            mdtnew(i,j) = mdtcor(i,j);
        elseif mdtt_alt(i,j) == 1
            mdtnew(i,j) = mdtt(i,j);
        else
            disp('ERRO!')
        end
        ciclos = ciclos + 1;
    end
    ciclos = ciclos + 1;
end
% Fix for backgound pixels
for i = 1:L_mdt
    for j = 1:C_mdt
        if mdtnew(i,j) <= -999 || mdtnew(i,j) > 999
            mdtnew(i,j) = NaN;
        else
        end
        ciclos = ciclos + 1;
    end
    ciclos = ciclos + 1;
end
% Data export
if dataf == 2020
    nome = 'dtm_final_2020.tif';
elseif dataf == 2030
    nome = 'dtm_final_2030.tif';
elseif dataf == 2040
    nome = 'dtm_final_2040.tif';
elseif dataf == 2050
    nome = 'dtm_final_2050.tif';
elseif dataf == 2060
    nome = 'dtm_final_2060.tif';
elseif dataf == 2070
    nome = 'dtm_final_2070.tif';
elseif dataf == 2080
    nome = 'dtm_final_2080.tif';
elseif dataf == 2090
    nome = 'dtm_final_2090.tif';
elseif dataf == 2100
    nome = 'dtm_final_2100.tif';
else
    nome = 'dtm_final.tif';
end
coordRefSysCode = 3763; % Coordinate System
geotiffwrite(nome, mdtnew, R_mdtt, 'CoordRefSysCode', coordRefSysCode); 
%
% Results
disp(' ')
disp('-------------------------------------------------------------------')
fprintf('The simulation was successfully completed! \n')
fprintf('%d cicles were counted. \n', ciclos)
disp('-------------------------------------------------------------------')
disp(' ')
pause(1)
disp('-------------------------------------------------------------------')
disp('The result was exported to the main folder (.tif)')
disp(' ')
fprintf('In %G, the transition levels are: \n',dataf)
fprintf('                    MHWN: %G m \n',PMAM_anual(end))
fprintf('                     MHW: %G m \n',PMMed_anual(end))
fprintf('                    MHWS: %G m \n',PMAV_anual(end))
disp(' ')
fprintf('In %G, the MSL will be %G m above the present MSL and it will be \n',dataf,NMM(end))
fprintf('rising at %G mm/year. \n', Taxa_anual(end)*1000)
disp('-------------------------------------------------------------------')
pause(0.5)
disp(' ')
disp('Contact: mfinacio@fc.ul.com')
disp('Faculty of Sciences of University of Lisbon')
disp(' ')


